AutoCAD Inventor :: Passing And Using Arrays In ILogic
Jul 14, 2012
I'm working on a small design project and creating a program in Inventor that utilizes a 2D Sketch to calculate the forces in a 2D static Bridge.... Although this is Besides the point.
In order to do what I want, I've found it will be easier to use Arrays. Unfortunately I'm having trouble passing arrays through various functions and setting them to each other.
These errors are constantly popping up
Rule Compile Errors in Bridge Stress, in Sketch Test Code.ipt
Error on Line 60 : Number of indices is less than the number of dimensions of the indexed array.
Error on Line 63 : Number of indices is less than the number of dimensions of the indexed array.
Error on Line 69 : Number of indices is less than the number of dimensions of the indexed array.
Error on Line 174 : Number of indices is less than the number of dimensions of the indexed array.
Error on Line 308 : Number of indices is less than the number of dimensions of the indexed array.
Attached you'll find the code I'm using.
View 1 Replies
ADVERTISEMENT
Aug 22, 2012
I have been attempting to pass a string array contained in a variant to the AutoCAD method AcadPlot.SetLayoutsToPlot. I am using late binding without a Interop assembly because we have several versions of AutoCAD in this company and I would like to support all of them from the same code base.The method wants a variant that contains a string array passed byref. The Microsoft documentation on COM interop from VB.NET makes it sound like the compiler will marshal it correctly by default, but it always throws a COMException (Exception from HRESULT: 0x80070057 (E_INVALIDARG)).
The stack trace shows it is trying to anyway:
StackTrace:
at Microsoft.VisualBasic.CompilerServices.LateBinding.InternalLateCall(Object o, Type objType, String name, Object[] args, String[] paramnames, Boolean[] CopyBack, Boolean IgnoreReturn)
at Microsoft.VisualBasic.CompilerServices.NewLateBinding.LateCall(Object Instance, Type Type, String MemberName, Object[] Arguments, String[] ArgumentNames, Type[] TypeArguments, Boolean[] CopyBack, Boolean IgnoreReturn)
But no matter how I code it I cannot get this variant array passed to AutoCAD.I have tried:
Imports System.Runtime.InteropServices
' VB default marshalling
Dim layoutarr = New Object() {"Layout1"}
doc.Plot.SetLayoutsToPlot(layoutarr)
' using a VariantWrapper
Dim layoutarr = New Object() {"Layout1"}
Dim wrapper As New System.Runtime.InteropServices.VariantWrapper(layoutarr)
doc.Plot.SetLayoutsToPlot(wrapper)
[code]...
As intensively as AutoCAD ActiveX uses variant arrays, I know this problem is going to come up again and again for me as I try to migrate code over to .NET.
View 5 Replies
View Related
May 23, 2012
Is there a way to declare a non-bound array (dynamic array?) in iLogic?
There are examples of set bounds array:
MyDoubleValues = New Double(){1.2,2.2,3.3}
But doing something like:
Dim MyDoubleValues() As Double ---Or--- MyDoubleValues = New Double()
Results in an error. On the other hand, the following totally works:
Dim MyDoubleValues(1) As Double
Which creates an array with a Ubound of 2
View 1 Replies
View Related
Aug 6, 2012
I am currently looking into mirroring and arrays and i wondered if it is possible to have some kind of adaptive mirroring activated or used.
The aim is as i change the instance which is arrayed or mirrored i want the objects in the array and the mirrored parts changed too.
If it is´not possible just like that i would want to do a macro or i logic form that updates the array or mirror to have matching parts again.
View 4 Replies
View Related
Jul 24, 2012
I am into tracking solar array's. So designing for high winds is paramount. I wonder if Inventor will have a package for analysis of wind loads. It is a different kind of FEA. Call it a 3-D distributed load.
View 5 Replies
View Related
Jun 30, 2004
I have a master layout (ipt), from which I've created derived parts, that get put together in an assembly. I'm able to pass parameters from my master part to the derived parts, but I don't seem to be able to pass parameters from the derived parts to the assembly. Is this possible?
View 9 Replies
View Related
Feb 10, 2011
I'm trying to create a .DLL to access a database from within iLogic. I'm new to VB.net so I'm having some trouble. I need to pass a multidimensional array as an argument to the DLL, but when I try to run the code I get an error that says "Number of indices exceeds the number of dimensions of the indexed array."
Here is my code..
The errors occur on the sData(0,i) and the sData(1,i)
I left all the database code off, because passing the array is the big issue I believe.
Public sub AddRecord(ByRef sData() As String)
For i = 0 to FieldQty
rst.Fields.Item(sData(0,i).Value = sData(1,i)
Next
End Sub
View 5 Replies
View Related
Dec 11, 2012
How do you save features added in an assembly to the part? For example, if I add a hole in an assembly, presently I cannot see it when I open the part. It seems like a very basic function, I'm not sure why it doesn't do it automatically.
View 6 Replies
View Related
Aug 19, 2013
how can I close an iLogic Form from either an iLogic Rule, or a VBA Rule (VBA is the Preferred method)?
View 5 Replies
View Related
Jul 13, 2013
How to make a new work plane rotated at an angle to another plane and passing through the axis of a cylinder, or one of the main axes.On the plane commands, in V2013, i don't find an option for plane at an angle
View 1 Replies
View Related
Nov 13, 2012
I'm trying to be able to have a function run another function with the secondary function being passed as an argument to the first. I'm trying to create a recursive function and the recursive part works great. I just need to be able to have the recursive function run other functions to actually do stuff.
Here is something I found that should do what I need, mainly run a function from a function name in a variable.
Sub test() Dim ftnName As String Dim argument As String Dim result As String ftnName = "myFunction" argument = "cat" result = Application.Run(ftnName, argument) MsgBox resultEnd SubFunction myFunction(inString As String) As String myFunction = inString & " has " & Len(inString) & " letters."End Function
However I get the error "object required" on the "result = Application.Run(ftnName, argument)" line. So I'm guessing the Inventor VBA doesn't like this method of doing this. I'm just hoping there is a way to do this or this function will be useless or reduced to hardcoding functions which still defeats the purpose.
View 2 Replies
View Related
Jul 23, 2013
Civil 3D 2014.I want to attach attribute information and/or metadata to my array. Is this possible?
If it is possible, I would also like to be able to explode my array and have my array items acquire the attribute information for exporting later. Can this be done as well?
View 1 Replies
View Related
Aug 9, 2012
I'm wondering how to create huge arrays in the best way. I have a circle and want it thousands of columns and tens of thousands of rows. Anytime I start to make this AutoCAD gets extremely slow and I was told that turning some into blocks would be best.
View 2 Replies
View Related
Jun 10, 2013
I am currently drawing a lithography mask in Autocad 2013 student version, where I created a lot of arrays. My problem is that I can't seem to align these structures. Some of them need to be aligned along the y-axis and some along the x-axis.
View 5 Replies
View Related
Apr 8, 2011
I've been trying to figure out if chaining parameters will accomplish what i'm trying to do, which is...
Imagine an elevation of a concrete pier or column showing the horizontal stirrup cage around the vertical reinforcement. If like to be able to use one parameter to control the space between elements (cage c/c) and another to control the total length of the array (height of column or # of cages). Then the actual number of elements would be total length/spacing.
Also, arrays alway seem to have fixed spacing, anyway to make the parameter control the spacing of the array?
View 7 Replies
View Related
Aug 8, 2012
I am trying to make a huge array of circles (4000 x 12000 or so). I work in microfabrication and need this to make a mask for lithography of a membrane. What is the best practice to minimize the memory usage? I.e. arrays, blocks, groups? I tried making an array of circles one row and 4000 columns then making that a block. Then repeating that block down for multiple rows, maybe 100, then making that a block. Repeating this until I have thousands of them. Is this the best way? It bogs down and gets incredible slow which I am hoping to avoid. I realize that it is inevitable that it will get slow with these huge numbers.
View 1 Replies
View Related
May 24, 2013
I have a need to save coordinates points for a couple of objects, so I decided to use a structure object.
Here is my structure for an 8 sided polygon:
Structure OctoPolygon Public Shared pt1 As New Geometry.Point3d Public Shared pt2 As New Geometry.Point3d Public Shared pt3 As New Geometry.Point3d Public Shared pt4 As New Geometry.Point3d Public Shared pt5 As New Geometry.Point3d Public Shared pt6 As New Geometry.Point3d Public Shared pt7 As New Geometry.Point3d Public Shared pt8 As New Geometry.Point3d Public Sub setPoints(ByVal drawingStartPoint As Double, ByVal mcSize As Double, ByVal mcCenter2Cham As Double)
[code]....
It says "Access of shared member, constant member, enum member, or nested type through an instance; qualifying expression wil not be evaluated"
how I can get the sub to see the points defined in the structure?
View 5 Replies
View Related
Jan 4, 2008
I am trying to create a block that polar arrays the street lamp, but every time i try i just move the grip for it, is there something i am missing?
View 8 Replies
View Related
Nov 20, 2012
I got a problem to pass parameter from VB to batch file. My code is below to run the batch file and to pass parameter.
Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
Dim input As String
Dim output AsString
input = "C:atchFile est.gds"
output ="C:atchFile est.dxf"
Dim batchFile As String = "C:atchFileLC_gds2dxf.bat"
Process.Start(batchFile, input & ""& output)
EndSub
With this code the output is like below:
If you look at the screen shot you can find out that input and output variable is passing to one variable LC_gdsin. But I want that output file location will be assigned to LC_dxfout. I tried a lot but could not able to do that.
I am using VB2010 premium and windows 7 32 bit pc
View 2 Replies
View Related
Oct 18, 2011
I recently added the QR Code plugin from the labs to ACAD 2012.
[URL]
It's pretty cool, and I have added it to one of my title blocks so that contractors can access more resources via their phones if they have questions on site. The code can be updated with a simple command QRED.
The downside of this, of course, is that I have to edit my block for every project. The documentation says that the encoded info is stored as XData. Is there a way to access this data via a field, or pass a variable/attribute through to the plugin to male this a bit easier?
View 0 Replies
View Related
Jul 9, 2013
I would like to use a string as a variable if this is possible. I've got:
new-pl-lay (as a variable that holds layer name "UGL_PL_NEW")
first-cable (as a string that holds "new-pl-lay")
I'd like set the current layer to "UGL_PL_NEW" by using the first-cable string.
Something like:
(command "_.layer" "m" (read first-cable) "")
View 8 Replies
View Related
Feb 14, 2011
I have 2 points and a line given (both points on one side of line)
I want to draw a circle so that it passes through two points and tangent to the given line.
View 9 Replies
View Related
Jul 30, 2013
I'm working on a script with an UI element. I want all values of the 2. cloumn (Rasterkeilfarbe) returned in one array and all values of the 3. column (Klischeenr.) returned in another arry.
var farben = ["black", "red", "blue", "green", "bla", "blupp"]
var myName = myInput (farben);
// rest of the script
[Code]....
View 5 Replies
View Related
Aug 14, 2012
Writing a routine that stores a file name as a string in variable FILE.I check the variable and it returns a nice quoted string: "filename-123.dwg"
I would like AutoCAD to open the file w/out user input.With FILEDIA set to 0, I've tried passing the variable to the command line:
(command "open" FILE)
or in a script as:
open
(FILE)
...
or,
open
!FILE
...
I get the same error. The string dumps to the command line and I get 'Unknown command "DWG" .'
View 9 Replies
View Related
Jul 25, 2012
The good news is that, if I were righting a routine that locks up AutoCAD, I'm finished. The bad news is that I'm not.
The code below is the portion of a routine where I have the user select 2 points and then pass those points to the Zoom command and the M2P osnap. The problem is that, when the Mid Between 2 Points osnap tries to use the first point, it returnns an "Invalid point" message, enters a loop and locks ACAD.
(defun C:ZC ()
(setq PointOne (getpoint "First point of M2P "))
(setq PointTwo (getpoint "Second point of M2P "))
[Code].....
View 2 Replies
View Related
Feb 29, 2012
I'm trying to complete the code to select a p-line on layer G-POLY-GSF w/o asking for input. this (setq ent (ssget "X" (list (cons 8 "G-POLY-GSF"))) dosen't seem to work. What I'm I missing here?
(defun cf8 (/ ent dist obj)
(vl-load-com)
(setq ent (car (entsel "
Select line to offset: "))
;(setq ent (ssget "X" (list (cons 8 "G-POLY-GSF")))
[Code]....
View 8 Replies
View Related
Nov 5, 2013
I'm trying to use iLogic Design Copy to copy an assembly and all its associated parts to another directory. The assembly contains content center parts. Inventor warns me that the destination file of one of the CC parts (and 18 others) will be overwritten. When I go ahead and copy anyway, the copying process stops at that specific CC part. The Design Copy Progress dialog box states there is an error copying that CC part. When I close the Design Copy Progress dialog box, Inventor crashes.
The error copying the CC part: I'm allowed to use content center parts in iLogic Design Copied stuff, right? I searched some related topics and I'm under the impression that Inventor keeps the CC parts in its own directory and shouldn't be trying to overwrite them.
View 3 Replies
View Related
Feb 10, 2012
1 - How to make arrays without copying and pasting? Fig-1
2 - how to create objects repeated in circles? Fig-2
View 6 Replies
View Related
Dec 7, 2012
I've just begun using Xara. I've used Corel before but can't see how to make pattern or arrays of objects in Xara. I'm needing to make mask templates for Watch faces, graphics mask for tire graphics etc.
View 4 Replies
View Related
Oct 23, 2012
How can I pass the contents of a cell value (text string) to Acad? I want the user to click on a cell, then have lisp use the string as the name of a block to insert.
View 4 Replies
View Related
Sep 16, 2013
I have a list function that asks for the user to pick points when it is run. It looks something like this (foo arg1 arg2) When invoked it asks the user to pick points and press enter when done It.
Instead of getting the points from the user i want to pass it a list of pre-defined points. The code cannot be changed so I must use it as is.Is this possible, if so how can it be done?
View 9 Replies
View Related